﻿using System;
using System.Linq;

namespace HeuristicLab.Tests.Benchmark
{
    public static class ExampleConverter
    {
        private const char ArrayValueSeparator = ' ';

        private static readonly char[] arraySymbolTrim = new[] { '[', ']' };

        public static Converter<string, long> Integer = new Converter<string, long>(GetInteger);
        public static Converter<string, long[]> Integers = new Converter<string, long[]>(GetIntegers);

        public static long GetInteger(string str)
        {
            return long.Parse(str);
        }

        public static long[] GetIntegers(string str)
        {
            var values = str
                .Trim(arraySymbolTrim)
                .Split(ArrayValueSeparator)
                .Where(s => !string.IsNullOrWhiteSpace(s))
                .ToList();

            var result = new long[values.Count];

            for (var i = 0; i < result.Length; i++)
            {
                result[i] = GetInteger(values[i]);
            }

            return result;
        }
    }
}
